# WoopsiUI::SliderHorizontal Class Reference

`#include <sliderhorizontal.h>`

Inheritance diagram for WoopsiUI::SliderHorizontal:

List of all members.

## Public Member Functions
| SliderHorizontal (s16 x, s16 y, u16 width, u16 height)
const s16 | getMinimumValue () const
const s16 | getMaximumValue () const
const s16 | getValue () const
const s16 | getPageSize () const
void | setMinimumValue (const s16 value)
void | setMaximumValue (const s16 value)
void | setValue (const s16 value)
void | setValueWithBitshift (const s32 value)
void | setPageSize (const s16 pageSize)
virtual void | handleDragEvent (const GadgetEventArgs &e)
s16 | getMinimumStep () const
## Protected Member Functions
s32 | getPhysicalMaximumValueWithBitshift () const
const s32 | getGripValue () const
virtual void | drawContents (GraphicsPort *port)
virtual void | drawBorder (GraphicsPort *port)
virtual void | onResize (u16 width, u16 height)
virtual void | onClick (s16 x, s16 y)
virtual | ~SliderHorizontal ()
| SliderHorizontal (const SliderHorizontal &sliderHorizontal)
void | resizeGrip ()
## Protected Attributes
SliderHorizontalGrip * | _grip
s16 | _minimumValue
s16 | _maximumValue
s32 | _value
s16 | _minimumGripWidth
s16 | _pageSize
s32 | _gutterWidth
u32 | _contentSize

## Detailed Description

Gadget providing a sliding "grip" that can be moved left and right in the "gutter". Essentially a scrollbar, but more generic.

## Constructor & Destructor Documentation

WoopsiUI::SliderHorizontal::SliderHorizontal | ( | s16 | x,
|  | s16 | y,
|  | u16 | width,
|  | u16 | height |
| ) |  |  |

Constructor.

Parameters:

  | x | The x co-ord of the slider, relative to its parent.
  | y | The y co-ord of the slider, relative to its parent.
  | width | The width of the slider.
  | height | The height of the slider.

virtual WoopsiUI::SliderHorizontal::~SliderHorizontal | ( |  | ) | `[inline, protected, virtual]`

Destructor.

WoopsiUI::SliderHorizontal::SliderHorizontal | ( | const SliderHorizontal & | sliderHorizontal | ) | `[inline, protected]`

Copy constructor is protected to prevent usage.

## Member Function Documentation

virtual void WoopsiUI::SliderHorizontal::drawBorder | ( | GraphicsPort * | port | ) | `[protected, virtual]`

Draw the area of this gadget that falls within the clipping region. Called by the redraw() function to draw all visible regions.

Parameters:

  | port | The GraphicsPort to draw to.

See also:
  redraw()

Reimplemented from WoopsiUI::Gadget.

virtual void WoopsiUI::SliderHorizontal::drawContents | ( | GraphicsPort * | port | ) | `[protected, virtual]`

Draw the area of this gadget that falls within the clipping region. Called by the redraw() function to draw all visible regions.

Parameters:

  | port | The GraphicsPort to draw to.

See also:
  redraw()

Reimplemented from WoopsiUI::Gadget.

const s32 WoopsiUI::SliderHorizontal::getGripValue | ( |  | ) | const`[protected]`

Get the value represented by the top of the grip. return The value represented by the top of the grip.

const s16 WoopsiUI::SliderHorizontal::getMaximumValue | ( |  | ) | const`[inline, virtual]`

Get the largest value that the slider can represent.

Returns:
  The largest value.

Implements WoopsiUI::SliderBase.

s16 WoopsiUI::SliderHorizontal::getMinimumStep | ( |  | ) | const

Get the smallest value that the slider can move through when dragged.

Returns:
  The smallest value that the slider can move through when dragged.

const s16 WoopsiUI::SliderHorizontal::getMinimumValue | ( |  | ) | const`[inline, virtual]`

Get the smallest value that the slider can represent.

Returns:
  The smallest value.

Implements WoopsiUI::SliderBase.

const s16 WoopsiUI::SliderHorizontal::getPageSize | ( |  | ) | const`[inline, virtual]`

Get the value represented by the height of the grip. For sliders, this would typically be 1 (so each new grip position is worth 1). For scrollbars, this would be the height of the scrolling gadget.

Returns:
  The page size.

Implements WoopsiUI::SliderBase.

s32 WoopsiUI::SliderHorizontal::getPhysicalMaximumValueWithBitshift | ( |  | ) | const`[protected]`

Get the maximum possible value that the slider can represent. Useful when using the slider as a scrollbar, as the height of the grip prevents the full range of values being accessed (intentionally). The returned value is bitshfted left 16 places for more accuracy in fixed-point calculations.

Returns:
  The maximum possible value that the slider can represent.

const s16 WoopsiUI::SliderHorizontal::getValue | ( |  | ) | const`[inline, virtual]`

Get the current value of the slider. return The current slider value.

Implements WoopsiUI::SliderBase.

virtual void WoopsiUI::SliderHorizontal::handleDragEvent | ( | const GadgetEventArgs & | e | ) | `[virtual]`

Process events fired by the grip.

Parameters:

  | e | The event details.

Reimplemented from WoopsiUI::GadgetEventHandler.

virtual void WoopsiUI::SliderHorizontal::onClick | ( | s16 | x,
|  | s16 | y |
| ) |  |  | `[protected, virtual]`

Moves the grip towards the stylus.

Parameters:

  | x | The x co-ordinate of the click.
  | y | The y co-ordinate of the click.

Reimplemented from WoopsiUI::Gadget.

virtual void WoopsiUI::SliderHorizontal::onResize | ( | u16 | width,
|  | u16 | height |
| ) |  |  | `[protected, virtual]`

Resize the slider to the new dimensions.

Parameters:

  | width | The new width.
  | height | The new height.

Reimplemented from WoopsiUI::Gadget.

void WoopsiUI::SliderHorizontal::resizeGrip | ( |  | ) | `[protected]`

Resize and redraw the grip.

void WoopsiUI::SliderHorizontal::setMaximumValue | ( | const s16 | value | ) | `[inline, virtual]`

Set the largest value that the slider can represent.

Parameters:

  | value | The largest value.

Implements WoopsiUI::SliderBase.

void WoopsiUI::SliderHorizontal::setMinimumValue | ( | const s16 | value | ) | `[inline, virtual]`

Set the smallest value that the slider can represent.

Parameters:

  | value | The smallest value.

Implements WoopsiUI::SliderBase.

void WoopsiUI::SliderHorizontal::setPageSize | ( | const s16 | pageSize | ) | `[inline, virtual]`

Set the page size represented by the grip.

Parameters:

  | pageSize | The page size.

See also:
  getPageSize().

Implements WoopsiUI::SliderBase.

void WoopsiUI::SliderHorizontal::setValue | ( | const s16 | value | ) | `[virtual]`

Set the value that of the slider. This will reposition and redraw the grip.

Parameters:

  | value | The new value.

Implements WoopsiUI::SliderBase.

void WoopsiUI::SliderHorizontal::setValueWithBitshift | ( | const s32 | value | ) | `[virtual]`

Set the value that of the slider. This will reposition and redraw the grip. The supplied value should be bitshifted left 16 places. This ensures greater accuracy than the standard setValue() method if the slider is being used as a scrollbar.

Parameters:

  | value | The new value.

Implements WoopsiUI::SliderBase.

## Member Data Documentation

u32 WoopsiUI::SliderHorizontal::_contentSize`[protected]`

Number of values in the min/max range.

SliderHorizontalGrip* WoopsiUI::SliderHorizontal::_grip`[protected]`

Pointer to the grip.

s32 WoopsiUI::SliderHorizontal::_gutterWidth`[protected]`

Width of the gutter, taking into account any adjustments made to the width of the grip.

s16 WoopsiUI::SliderHorizontal::_maximumValue`[protected]`

Maximum value that the grip can represent.

s16 WoopsiUI::SliderHorizontal::_minimumGripWidth`[protected]`

Smallest width that the grip can become

s16 WoopsiUI::SliderHorizontal::_minimumValue`[protected]`

Minimum value that the grip can represent.

s16 WoopsiUI::SliderHorizontal::_pageSize`[protected]`

Value of a page of data, used when clicking the gutter.

s32 WoopsiUI::SliderHorizontal::_value`[protected]`

Current value of the slider.

The documentation for this class was generated from the following file:

- sliderhorizontal.h